/*
 * Figshare API
 *
 * Figshare apiv2. Using Swagger 2.0
 *
 * API version: 2.0.0
 * Generated by: Swagger Codegen (https://github.com/swagger-api/swagger-codegen.git)
 */

package swagger

type ArticleUpdate struct {
	// Title of article
	Title string `json:"title,omitempty"`
	// The article description. In a publisher case, usually this is the remote article description
	Description string `json:"description,omitempty"`
	// True if article has no files
	IsMetadataRecord bool `json:"is_metadata_record,omitempty"`
	// Article metadata reason
	MetadataReason string `json:"metadata_reason,omitempty"`
	// List of tags to be associated with the article. Keywords can be used instead
	Tags []string `json:"tags,omitempty"`
	// List of tags to be associated with the article. Tags can be used instead
	Keywords []string `json:"keywords,omitempty"`
	// List of links to be associated with the article (e.g [\"http://link1\", \"http://link2\", \"http://link3\"])
	References []string `json:"references,omitempty"`
	// List of related materials; supersedes references and resource DOI/title.
	RelatedMaterials []RelatedMaterial `json:"related_materials,omitempty"`
	// List of category ids to be associated with the article(e.g [1, 23, 33, 66])
	Categories []int64 `json:"categories,omitempty"`
	// List of category source ids to be associated with the article, supersedes the categories property
	CategoriesBySourceId []string `json:"categories_by_source_id,omitempty"`
	// List of authors to be associated with the article. The list can contain the following fields: id, name, first_name, last_name, email, orcid_id. If an id is supplied, it will take priority and everything else will be ignored. For adding more authors use the specific authors endpoint.
	Authors []interface{} `json:"authors,omitempty"`
	// List of key, values pairs to be associated with the article
	CustomFields interface{} `json:"custom_fields,omitempty"`
	// List of custom fields values, supersedes custom_fields parameter
	CustomFieldsList []CustomArticleFieldAdd `json:"custom_fields_list,omitempty"`
	// <b>One of:</b> <code>figure</code> <code>online resource</code> <code>preprint</code> <code>book</code> <code>conference contribution</code> <code>media</code> <code>dataset</code> <code>poster</code> <code>journal contribution</code> <code>presentation</code> <code>thesis</code> <code>software</code>
	DefinedType string `json:"defined_type,omitempty"`
	// Grant number or funding authority
	Funding string `json:"funding,omitempty"`
	// Funding creation / update items
	FundingList []FundingCreate `json:"funding_list,omitempty"`
	// License id for this article.
	License int64 `json:"license,omitempty"`
	// Not applicable for regular users. In an institutional case, make sure your group supports setting DOIs. This setting is applied by figshare via opening a ticket through our support/helpdesk system.
	Doi string `json:"doi,omitempty"`
	// Not applicable for regular users. In an institutional case, make sure your group supports setting Handles. This setting is applied by figshare via opening a ticket through our support/helpdesk system.
	Handle string `json:"handle,omitempty"`
	// Deprecated by related materials. Not applicable to regular users. In a publisher case, this is the publisher article DOI.
	ResourceDoi string `json:"resource_doi,omitempty"`
	// Deprecated by related materials. Not applicable to regular users. In a publisher case, this is the publisher article title.
	ResourceTitle string `json:"resource_title,omitempty"`
	// Various timeline dates
	Timeline *TimelineUpdate `json:"timeline,omitempty"`
	// If true, downloading of files for this article is disabled
	DownloadDisabled bool `json:"download_disabled,omitempty"`
	// Not applicable to regular users. This field is reserved to institutions/publishers with access to assign to specific groups
	GroupId int64 `json:"group_id,omitempty"`
}
