/*
 * Figshare API
 *
 * Figshare apiv2. Using Swagger 2.0
 *
 * API version: 2.0.0
 * Generated by: Swagger Codegen (https://github.com/swagger-api/swagger-codegen.git)
 */

package swagger

type ProjectArticle struct {
	// Unique identifier for article
	Id int64 `json:"id"`
	// Title of article
	Title string `json:"title"`
	// DOI
	Doi string `json:"doi"`
	// Handle
	Handle string `json:"handle"`
	// Api endpoint for article
	Url string `json:"url"`
	// Public site endpoint for article
	UrlPublicHtml string `json:"url_public_html"`
	// Public Api endpoint for article
	UrlPublicApi string `json:"url_public_api"`
	// Private site endpoint for article
	UrlPrivateHtml string `json:"url_private_html"`
	// Private Api endpoint for article
	UrlPrivateApi string `json:"url_private_api"`
	// Various timeline dates
	Timeline *Timeline `json:"timeline"`
	// Thumbnail image
	Thumb string `json:"thumb"`
	// Type of article identifier
	DefinedType int64 `json:"defined_type"`
	// Name of the article type identifier
	DefinedTypeName string `json:"defined_type_name"`
	// Article citation
	Citation string `json:"citation"`
	// Confidentiality reason
	ConfidentialReason string `json:"confidential_reason"`
	// Article Confidentiality
	IsConfidential bool `json:"is_confidential"`
	// Article size
	Size int64 `json:"size"`
	// Article funding
	Funding string `json:"funding"`
	// Full Article funding information
	FundingList []FundingInformation `json:"funding_list"`
	// List of article tags
	Tags []string `json:"tags"`
	// Article version
	Version int64 `json:"version"`
	// True if article is active
	IsActive bool `json:"is_active"`
	// True if article has no files
	IsMetadataRecord bool `json:"is_metadata_record"`
	// Article metadata reason
	MetadataReason string `json:"metadata_reason"`
	// Article status
	Status string `json:"status"`
	// Article description
	Description string `json:"description"`
	// True if article is embargoed
	IsEmbargoed bool `json:"is_embargoed"`
	// True if article is published
	IsPublic bool `json:"is_public"`
	// Date when article was created
	CreatedDate string `json:"created_date"`
	// True if any files are linked to the article
	HasLinkedFile bool `json:"has_linked_file"`
	// List of categories selected for the article
	Categories []Category `json:"categories"`
	// Article selected license
	License *License `json:"license"`
	// Title for embargo
	EmbargoTitle string `json:"embargo_title"`
	// Reason for embargo
	EmbargoReason string `json:"embargo_reason"`
	// List of references
	References []string `json:"references"`
	// List of related materials; supersedes references and resource DOI/title.
	RelatedMaterials []RelatedMaterial `json:"related_materials,omitempty"`
}
